//+------------------------------------------------------------------
//|
//| original can be found here http://www.trade2win.com/boards/forex-strategies-systems/71854-correlation-trading-basic-ideas-strategies-64.html
//| this wersion was made by mladen
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_level1 0.0

//
//
//
//
//

extern string Parameters    = "Parameters";
extern int    PerAvr        =  20;
extern int    Delta         =   1;
extern bool   EURShow       = true;
extern color  EURColor      = DeepSkyBlue;
extern bool   GBPShow       = true;
extern color  GBPColor      = Magenta;
extern bool   AUDShow       = true;
extern color  AUDColor      = Goldenrod;
extern bool   CHFShow       = true;
extern color  CHFColor      = Orange;
extern bool   JPYShow       = true;
extern color  JPYColor      = Gold;
extern bool   NZDShow       = true;
extern color  NZDColor      = Aqua;
extern bool   CADShow       = true;
extern color  CADColor      = Red;
extern bool   USDShow       = true;
extern color  USDColor      = Lime;
extern int    LinesWidth    = 1;
extern string SymbolPrefix  = "";
extern string SymbolSuffix  = "";
extern double Smooth        = 5;
extern double SmoothPhase   = 0;
extern bool   ArrowsOnSlope = false;
extern string UniqueID      = "FX correlator 3";

//
//
//
//
//

double Idx0[],Idx1[],Idx2[],Idx3[],Idx4[],Idx5[],Idx6[],Idx7[];
string Currencies[] = {"EUR","GBP","AUD","CHF","JPY","NZD","CAD","USD"};
int    Colors[8];
string ShortName;
bool   returnBars;
string indicatorFileName;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Idx0);
   SetIndexBuffer(1,Idx1);
   SetIndexBuffer(2,Idx2);
   SetIndexBuffer(3,Idx3);
   SetIndexBuffer(4,Idx4);
   SetIndexBuffer(5,Idx5);
   SetIndexBuffer(6,Idx6);
   SetIndexBuffer(7,Idx7);
         Colors[0] = EURColor; Colors[1] = GBPColor; Colors[2] = AUDColor; 
         Colors[3] = CHFColor; Colors[4] = JPYColor; Colors[5] = NZDColor; 
         Colors[6] = CADColor; Colors[7] = USDColor;
         
         //
         //
         //
         //
         //
         
         indicatorFileName = WindowExpertName();
         returnBars = (Parameters=="returnBars");
         ShortName = UniqueID+" ("+PerAvr+"/"+Delta+")";
   IndicatorShortName(ShortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID;
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

#define ystep 17
int start()
{  
   int i,r,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-1,Bars-counted_bars);
         if (returnBars) { Idx0[0]=limit; return(0); }
         
      //
      //
      //
      //
      //
         
      static bool initialized = false;
            if (!initialized )
            {
               int x      = 40;
               int y      = 10;
               int window = WindowFind(ShortName);

                  for (i = 0; i<8; i++,y+=ystep)
                  {
                     SetIndexLabel(i,Currencies[i]);
                     SetIndexStyle(i,DRAW_LINE,EMPTY,LinesWidth,Colors[i]); 
                     
                        string name = UniqueID+"obj_"+Currencies[i];
                           ObjectCreate(name,OBJ_LABEL,window,0,0);
                              ObjectSet(name,OBJPROP_XDISTANCE,x);
                              ObjectSet(name,OBJPROP_YDISTANCE,y);
                              ObjectSet(name,OBJPROP_CORNER,1);
                              ObjectSetText(name,Currencies[i],10,"Arial bold",Colors[i]);
                  }
                  initialized = true;
            }
            checkLimit("EURUSD",limit);
            checkLimit("GBPUSD",limit);
            checkLimit("AUDUSD",limit);
            checkLimit("USDCHF",limit);
            checkLimit("USDJPY",limit);
            checkLimit("NZDUSD",limit);
            checkLimit("USDCAD",limit);
    
   //
   //
   //
   //
   //
              
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)    
   {
      double A1 = (iMA(SymbolPrefix+"EURUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i)      -iMA("EURUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta))/1; 
      double A2 = (iMA(SymbolPrefix+"GBPUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i)      -iMA("GBPUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta))/1; 
      double A3 = (iMA(SymbolPrefix+"AUDUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i)      -iMA("AUDUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta))/1; 
      double A4 = (iMA(SymbolPrefix+"USDCHF"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta)-iMA("USDCHF"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i      ))/1;
      double A5 = (iMA(SymbolPrefix+"USDJPY"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta)-iMA("USDJPY"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i      ))/100; 
      double A6 = (iMA(SymbolPrefix+"NZDUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i)      -iMA("NZDUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta))/1;
      double A7 = (iMA(SymbolPrefix+"USDCAD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta)-iMA("USDCAD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i      ))/1;
      
      double USD = -(A1+A2+A3+A4+A5+A6+A7)/7;
      double EUR =  A1-(A2+A3+A4+A5+A6+A7)/6;
      double GBP =  A2-(A1+A3+A4+A5+A6+A7)/6;
      double AUD =  A3-(A1+A2+A4+A5+A6+A7)/6;     
      double CHF =  A4-(A1+A2+A3+A5+A6+A7)/6;  
      double JPY =  A5-(A1+A2+A3+A4+A6+A7)/6;
      double NZD =  A6-(A1+A2+A3+A4+A5+A7)/6;
      double CAD =  A7-(A1+A2+A3+A4+A5+A6)/6;

      //
      //
      //
      //
      //

         if ( EURShow ) { Idx0[i] = iSmooth(EUR,Smooth,SmoothPhase,i,0); checkRiseFall(Idx0,0,i); }
         if ( GBPShow ) { Idx1[i] = iSmooth(GBP,Smooth,SmoothPhase,i,1); checkRiseFall(Idx1,1,i); }
         if ( AUDShow ) { Idx2[i] = iSmooth(AUD,Smooth,SmoothPhase,i,2); checkRiseFall(Idx2,2,i); }
         if ( CHFShow ) { Idx3[i] = iSmooth(CHF,Smooth,SmoothPhase,i,3); checkRiseFall(Idx3,3,i); }
         if ( JPYShow ) { Idx4[i] = iSmooth(JPY,Smooth,SmoothPhase,i,4); checkRiseFall(Idx4,4,i); }
         if ( NZDShow ) { Idx5[i] = iSmooth(NZD,Smooth,SmoothPhase,i,5); checkRiseFall(Idx5,5,i); }
         if ( CADShow ) { Idx6[i] = iSmooth(CAD,Smooth,SmoothPhase,i,6); checkRiseFall(Idx6,6,i); }
         if ( USDShow ) { Idx7[i] = iSmooth(USD,Smooth,SmoothPhase,i,7); checkRiseFall(Idx7,7,i); }
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void checkLimit(string symbol, int& limit)
{
   string checkSymbol = symbol+SymbolSuffix;
      if (checkSymbol!=Symbol())
         limit = MathMin(Bars-1,iCustom(checkSymbol,0,indicatorFileName,"returnBars",0,0));
}

//
//
//
//
//

void checkRiseFall(double& array[], int forSymbol, int i)
{
   int window = WindowFind(ShortName);

   //
   //
   //
   //
   //
   
   if (i==0)
   {
      string arrow = "";
      if (ArrowsOnSlope)
      {
         if (array[i]>array[i+1]) arrow = "";
         if (array[i]<array[i+1]) arrow = "";
      }
      else
      {
         if (array[i]>0) arrow = "";
         if (array[i]<0) arrow = "";
      }         
      
      //
      //
      //
      //
      //
         
         string name = UniqueID+"arrow_"+Currencies[forSymbol];
            ObjectCreate(name,OBJ_LABEL,window,0,0);
               ObjectSet(name,OBJPROP_XDISTANCE,10);
               ObjectSet(name,OBJPROP_YDISTANCE,10+forSymbol*ystep);
               ObjectSet(name,OBJPROP_CORNER,1);
               ObjectSetText(name,arrow,12,"Wingdings",Colors[forSymbol]);
   }      
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double wrk[][80];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars); s*= 10;
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}